/*
 * generated by Xtext
 */
package fr.irisa.cairn.formatting;

import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;

import fr.irisa.cairn.services.JniMapGrammarAccess;

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
public class JniMapFormatter extends AbstractDeclarativeFormatter {
	
	@Override
	protected void configureFormatting(FormattingConfig c) {
		JniMapGrammarAccess g = (JniMapGrammarAccess)getGrammarAccess();
		
		c.setAutoLinewrap(500);
		
		c.setLinewrap(1, 1, 2).after(g.getMappingAccess().getSemicolonKeyword_5());
		//host enumeration
		c.setNoSpace().around(g.getMappingAccess().getLeftSquareBracketKeyword_4_0());
		c.setNoSpace().around(g.getHostTypeAccess().getCygwin32Cygwin_32Keyword_5_0());
		c.setNoSpace().around(g.getHostTypeAccess().getLinux32Linux_32Keyword_0_0());
		c.setNoSpace().around(g.getHostTypeAccess().getLinux64Linux_64Keyword_1_0());
		c.setNoSpace().around(g.getHostTypeAccess().getMacosx32Macosx_32Keyword_2_0());
		c.setNoSpace().around(g.getHostTypeAccess().getMacosx64Macosx_64Keyword_3_0());
		c.setNoSpace().around(g.getMappingAccess().getRightSquareBracketKeyword_4_3());
		c.setNoSpace().before(g.getMappingAccess().getCommaKeyword_4_2_0());
		
		//Library decl
		c.setLinewrap().after(g.getLibraryAccess().getLeftCurlyBracketKeyword_1());
		c.setLinewrap(1, 1, 2).after(g.getLibraryAccess().getRightCurlyBracketKeyword_7());
		c.setLinewrap().after(g.getLibraryAccess().getSemicolonKeyword_5());
		c.setLinewrap().after(g.getLibraryAccess().getSemicolonKeyword_6_1());
		c.setNoSpace().after(g.getLibraryAccess().getNameAssignment_4());
		c.setNoSpace().after(g.getLibraryAccess().getFilenamesAssignment_6_0());
		c.setIndentationIncrement().after(g.getLibraryAccess().getLeftCurlyBracketKeyword_1());
		c.setIndentationDecrement().before(g.getLibraryAccess().getRightCurlyBracketKeyword_7());
		
		//include
		c.setLinewrap(1, 1, 2).after(g.getIncludeDefAccess().getSemicolonKeyword_2());
		c.setNoSpace().around(g.getIncludeDefAccess().getIncludeAssignment_1());
		
		//module
		c.setLinewrap().after(g.getUserModuleAccess().getLeftCurlyBracketKeyword_2());
		c.setLinewrap(1, 1, 2).after(g.getUserModuleAccess().getRightCurlyBracketKeyword_4());
		c.setIndentationIncrement().after(g.getUserModuleAccess().getLeftCurlyBracketKeyword_2());
		c.setIndentationDecrement().before(g.getUserModuleAccess().getRightCurlyBracketKeyword_4());
		
		//class mapping
		//class
		c.setLinewrap(1, 1, 2).after(g.getClassToClassMappingAccess().getSemicolonKeyword_4());
		c.setLinewrap().after(g.getClassDeclarationAccess().getLeftCurlyBracketKeyword_2_0());
		c.setLinewrap(1, 1, 2).after(g.getClassDeclarationAccess().getSemicolonKeyword_2_1_1());
		c.setIndentationIncrement().after(g.getClassDeclarationAccess().getLeftCurlyBracketKeyword_2_0());
		c.setIndentationDecrement().before(g.getClassDeclarationAccess().getRightCurlyBracketKeyword_2_2());
		c.setNoSpace().before(g.getClassDeclarationAccess().getSemicolonKeyword_2_1_1());
		c.setNoSpace().before(g.getClassToClassMappingAccess().getSemicolonKeyword_4());
		
		//struct
		c.setLinewrap(1, 1, 2).after(g.getStructToClassMappingAccess().getSemicolonKeyword_4());
		c.setLinewrap().after(g.getStructDeclarationAccess().getLeftCurlyBracketKeyword_2_0());
		c.setLinewrap(1, 1, 2).after(g.getStructDeclarationAccess().getSemicolonKeyword_2_1_1());
		c.setIndentationIncrement().after(g.getStructDeclarationAccess().getLeftCurlyBracketKeyword_2_0());
		c.setIndentationDecrement().before(g.getStructDeclarationAccess().getRightCurlyBracketKeyword_2_2());
		c.setNoSpace().before(g.getStructDeclarationAccess().getSemicolonKeyword_2_1_1());
		c.setNoSpace().before(g.getStructToClassMappingAccess().getSemicolonKeyword_4());
		
		//alias
		c.setLinewrap().after(g.getAliasToClassMappingAccess().getSemicolonKeyword_6());
		c.setNoSpace().before(g.getAliasToClassMappingAccess().getSemicolonKeyword_6());
		
		//enum
		c.setLinewrap(1, 1, 2).after(g.getEnumToClassMappingAccess().getSemicolonKeyword_3());
		c.setLinewrap().after(g.getEnumDeclarationAccess().getLeftCurlyBracketKeyword_2_0());
		c.setLinewrap().before(g.getEnumDeclarationAccess().getRightCurlyBracketKeyword_2_3());
		c.setLinewrap().after(g.getEnumDeclarationAccess().getCommaKeyword_2_2_0());
		c.setIndentationIncrement().after(g.getEnumDeclarationAccess().getLeftCurlyBracketKeyword_2_0());
		c.setIndentationDecrement().before(g.getEnumDeclarationAccess().getRightCurlyBracketKeyword_2_3());
		c.setNoSpace().before(g.getEnumToClassMappingAccess().getSemicolonKeyword_3());
		
		
		//method group
		c.setLinewrap().after(g.getMethodGroupAccess().getLeftCurlyBracketKeyword_2());
		c.setLinewrap(1, 1, 2).after(g.getMethodGroupAccess().getRightCurlyBracketKeyword_4());
		c.setIndentationIncrement().after(g.getMethodGroupAccess().getLeftCurlyBracketKeyword_2());
		c.setIndentationDecrement().before(g.getMethodGroupAccess().getRightCurlyBracketKeyword_4());
		
		
		//method
		c.setLinewrap().after(g.getMethodAccess().getRightSquareBracketKeyword_0_2());
		c.setLinewrap(1, 1, 2).after(g.getMethodAccess().getSemicolonKeyword_7());
		
		c.setNoSpace().before(g.getMethodAccess().getCommaKeyword_5_1_0());
		c.setNoSpace().around(g.getMethodAccess().getLeftParenthesisKeyword_4());
		c.setNoSpace().around(g.getMethodAccess().getRightParenthesisKeyword_6());
		c.setNoSpace().after(g.getMethodAccess().getLeftSquareBracketKeyword_0_0());
		c.setNoSpace().before(g.getMethodAccess().getRightSquareBracketKeyword_0_2());
		c.setNoSpace().around(g.getMethodAccess().getEqualsSignKeyword_0_1_3_1());
		c.setNoSpace().around(g.getMethodAccess().getEqualsSignKeyword_0_1_5_1());
		
		//cmethod
		c.setLinewrap(1, 1, 2).after(g.getCMethodAccess().getSemicolonKeyword_6());
		c.setNoSpace().before(g.getCMethodAccess().getCommaKeyword_4_1_0());
		c.setNoSpace().around(g.getCMethodAccess().getLeftParenthesisKeyword_3());
		c.setNoSpace().around(g.getCMethodAccess().getRightParenthesisKeyword_5());

		c.setNoSpace().before(g.getPtrTypeAccess().getIndirAssignment_1());
		c.setSpace(" ").after(g.getPtrTypeAccess().getIndirAssignment_1());


		//comments
		c.setLinewrap(0, 1, 2).before(g.getSL_COMMENTRule());
		c.setLinewrap(0, 1, 2).before(g.getML_COMMENTRule());
		c.setLinewrap(0, 1, 1).after(g.getML_COMMENTRule());
		
	}
}
